#
# extrefparser.rb
#
#   Copyright (c) 2001,2002 Minero Aoki <aamine@loveruby.net>
#
#   This program is free software.
#   you can distribute/modify this program under the terms of
#   the GNU Lesser General Public License version 2 or later.
#

require 'refe/rdutils'


module ReFe

  class ExtentionAPIReferenceParser

    ::ReFe.declear_parser self

    include RDUtils

    def self.process( fname, db, msgout )
      msgout.print_filename fname
      db.f_doc_updating {
          File.open(fname) {|f|
              new.process f, db
          }
      }
    end

    def process( f, db )
      parse(f).each do |name,str|
        db.register_fdoc name, str.strip
      end
    end

    private

    def parse( f )
      table = {}
      curr = nil

      f.each do |line|
        next if /\A[=\w]/ === line
        if /\A: / === line
          untag! curr
          case line
          when /(\w+)\(/, /(\w+)/
            table[$1] = curr = line
          else
            raise "parse failed: #{line.inspect}"
          end
        else
          curr << line if curr
        end
      end
      untag! curr

      table
    end
  
  end

end
